'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var ExprRe = (function (_Atom) {
  function ExprRe(expr) {
    var group = arguments[1] === undefined ? 0 : arguments[1];

    _classCallCheck(this, ExprRe);

    _Atom.call(this);
    this._pattern = new RegExp('^(?:' + expr.source + ')', expr.flags);
    this._group = group;
    this._origin = expr;
  }

  _inherits(ExprRe, _Atom);

  ExprRe.prototype.run = function run(stream, index) {
    var match = this._pattern.exec(stream.substr(index));
    if (match) {
      var fullMatch = match[0];
      var groupMatch = match[this._group];

      if (groupMatch != null) {
        return this._resolve(index + fullMatch.length, groupMatch);
      }
    }

    return this._reject(index, this._origin);
  };

  return ExprRe;
})(_Atom3['default']);

exports['default'] = ExprRe;
module.exports = exports['default'];