'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var Repetition = (function (_Atom) {
  function Repetition(atom, min, max) {
    var tag = arguments[3] === undefined ? 'repetition' : arguments[3];

    _classCallCheck(this, Repetition);

    _Atom.call(this);

    if (max < min) {
      throw new Error();
    }

    this._atom = atom;
    this._min = min;
    this._max = max;
    this._tag = tag;
  }

  _inherits(Repetition, _Atom);

  Repetition.prototype.run = function run(stream, index) {
    var values = [this._tag];
    var result = undefined;

    for (var iteration = 0; iteration < this._max; iteration++) {
      result = this._atom.run(stream, index).aggregate(result);

      if (result.status) {
        values.push(result.value);
        index = result.index;
        continue;
      }

      if (iteration >= this._min) {
        break;
      }

      return result;
    }

    return this._resolve(index, values).aggregate(result);
  };

  return Repetition;
})(_Atom3['default']);

exports['default'] = Repetition;
module.exports = exports['default'];