'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var Sequence = (function (_Atom) {
  function Sequence(atoms) {
    _classCallCheck(this, Sequence);

    _Atom.call(this);
    this._atoms = atoms;
  }

  _inherits(Sequence, _Atom);

  Sequence.prototype.run = function run(stream, index) {
    var values = ['sequence'];
    var result = undefined;

    for (var i = 0; i < this._atoms.length; i++) {
      result = this._atoms[i].run(stream, index).aggregate(result);

      if (!result.status) {
        return result;
      }

      values.push(result.value);
      index = result.index;
    }

    return this._resolve(index, values).aggregate(result);
  };

  return Sequence;
})(_Atom3['default']);

exports['default'] = Sequence;
module.exports = exports['default'];