'use strict';

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

exports.__esModule = true;
// Atoms
// -----

var _Custom = require('./atoms/custom');

var _Custom2 = _interopRequireWildcard(_Custom);

var _Lazy = require('./atoms/lazy');

var _Lazy2 = _interopRequireWildcard(_Lazy);

var _Alternative = require('./atoms/alternative');

var _Alternative2 = _interopRequireWildcard(_Alternative);

var _Sequence = require('./atoms/sequence');

var _Sequence2 = _interopRequireWildcard(_Sequence);

var _ExprAny = require('./atoms/expr_any');

var _ExprAny2 = _interopRequireWildcard(_ExprAny);

var _ExprRe = require('./atoms/expr_re');

var _ExprRe2 = _interopRequireWildcard(_ExprRe);

var _ExprStr = require('./atoms/expr_str');

var _ExprStr2 = _interopRequireWildcard(_ExprStr);

// Chains
// ------

var _Atom = require('./atoms/base');

var _Atom2 = _interopRequireWildcard(_Atom);

var _methods = require('./atoms/dsl');

var _methods2 = _interopRequireWildcard(_methods);

// Export Atom API
var alt = function alt() {
  for (var _len = arguments.length, parsers = Array(_len), _key = 0; _key < _len; _key++) {
    parsers[_key] = arguments[_key];
  }

  return new _Alternative2['default'](parsers);
};
exports.alt = alt;
var seq = function seq() {
  for (var _len2 = arguments.length, parsers = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    parsers[_key2] = arguments[_key2];
  }

  return new _Sequence2['default'](parsers);
};
exports.seq = seq;
var custom = function custom(fn) {
  return new _Custom2['default'](fn);
};
exports.custom = custom;
var lazy = function lazy(fn) {
  return new _Lazy2['default'](fn);
};
exports.lazy = lazy;
var any = function any() {
  return new _ExprAny2['default']();
};
exports.any = any;
var str = function str(string) {
  return new _ExprStr2['default'](string);
};
exports.str = str;
var match = function match(regex) {
  return new _ExprRe2['default'](regex);
};exports.match = match;

// Export Chain API
var _ = _Atom2['default'].prototype;

exports._ = _;
// Install chainable methods
for (var _name in _methods2['default']) {
  _[_name] = _methods2['default'][_name];
}